/**
 * ----------------------------------------------------------------------------------
 *
 * Copyright (C) 2011 runlevel3 GmbH Berlin
 *
 * ----------------------------------------------------------------------------------
 *
 * LICENSE:
 *
 * This file is part of USB-AD-Interface.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * ----------------------------------------------------------------------------------
 *
 * Qt Creator 2.2.1 / Qt 4.7.3
 *
 * ----------------------------------------------------------------------------------
 *
 * @copyright 2011 runlevel3 GmbH
 * @license   http://www.gnu.org/licenses/gpl.txt GNU General Public License v3
 * @link      http://www.runlevel3.de runlevel3
 **/


#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>

#include "adconverter.h"

namespace Ui {
    class MainWindow;
}

class MainWindow : public QMainWindow {
    Q_OBJECT
public:
    MainWindow(QWidget *parent = 0);
    ~MainWindow();

protected:
    void changeEvent(QEvent *e);

private:
    Ui::MainWindow *ui;
    void ui_refresh(Ui::MainWindow *ui, int refresh_type);
    QTimer *ADTimer0, *RefreshTimer0;
    ADConverter *ADConverter0;
    QWidget *statusClearButton;

private slots:
    void on_spinBox_Loops_valueChanged(int );
    void on_actionConnect_triggered();
    void on_actionQuit_triggered();
    void on_spinBox_Gain_valueChanged(int );
    void on_checkBox_ComputeGain_clicked();
    void on_checkBox_Unipolar_clicked();
    void on_lineEdit_AD_textChanged(QString );
    void on_pushButton_Convert_clicked();
    void on_lineEdit_Vref_editingFinished();
    void on_spinBox_ADInterval_valueChanged(int );
    void on_checkBox_ADAuto_toggled(bool checked);
    void on_checkBox_StartupOffset_toggled(bool checked);
    void on_pushButton_EepromSave_clicked();
    void on_pushButton_EepromReset_clicked();
    void on_pushButton_GainSystemCalibration_clicked();
    void on_pushButton_OffsetSelfCalibration_clicked();
    void on_pushButton_OffsetSystemCalibration_clicked();
    void on_lineEdit_Offset_returnPressed();
    void on_lineEdit_Gain_returnPressed();
    void on_lineEdit_Offset_textChanged(QString );
    void on_lineEdit_Gain_textChanged(QString );
    void statusClearButton_clicked();
    void ADTimerUpdate();
    void RefreshTimerUpdate();
    void on_actionReboot_triggered();
    void on_actionAbout_triggered();
};

#endif // MAINWINDOW_H
